/**
 * 
  askeyboard.ino  Main sketch of "ASkeyboard Hobo-nicola version".
  Copyright (c) 2018 Takeshi Higasa
  
  This file is part of "Hobo-nicola keyboard programs".

  "Hobo-nicola keyboard adapter" is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  "Hobo-nicola keyboard adapter" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with "Hobo-nicola keyboard adapter".  If not, see <http://www.gnu.org/licenses/>.
  
  askeyboard.ino included in hoboNicola Library 1.2.1.  Dec. 10, 2018
  
*/

#include "nicola_keyboard.h"
#include "ASkeyboard.h"

NicolaKeyboard hobo_nicola;

class kbd_event : public keyboard_notify {
  public:
    virtual void modifier_changed(uint8_t before, uint8_t after) { hobo_nicola.modifier_change(before, after); }
    virtual void raw_key_event(uint8_t key, bool released = false) {}
    virtual void key_pressed  (uint8_t key, uint8_t mod) { hobo_nicola.key_press(key, mod);  }
    virtual void key_released  (uint8_t key, uint8_t mod) { hobo_nicola.key_release(key, mod); };
    virtual void key_released_all () { hobo_nicola.releaseAll(); }
};

static void askb_setup(uint8_t u) {
  hobo_nicola.enter_setup_mode();
}

ASkeyboard* askb;
void setup() {
  askb = ASkeyboard::getInstance();
  askb->set_setup_fn(askb_setup);
  askb->begin(new kbd_event);
}

void loop() {
  askb->task(hobo_nicola.get_hid_led_state());
  hobo_nicola.idle(); 
  hobo_nicola.set_disable_nicola(askb->is_nicola_disabled());	// JIS mode.
  hobo_nicola.has_dedicated_oyakeys(askb->dedicated_oyayubi());
  askb->setup_led(hobo_nicola.is_setup_mode());
}