#include "nicola_keyboard.h"

#include "ASkeyboard.h"

class kbd_event : public keyboard_notify {
  public:
    virtual void modifier_changed(uint8_t before, uint8_t after);
    virtual void raw_key_event(uint8_t key, bool released = false) {}
    virtual void key_pressed  (uint8_t key, uint8_t mod) ;
    virtual void key_released  (uint8_t key, uint8_t mod) ;
    virtual void key_released_all  () { Serial.println("KEY_RELEASED_ALL"); };
};

void kbd_event::key_pressed(uint8_t k, uint8_t mod) {
  char tmp[40];
  sprintf(tmp, "key_pressed() k = %02X, mod=%02X\n", k, mod);
  Serial.print(tmp);
}

void kbd_event::key_released(uint8_t k, uint8_t mod) {
  char tmp[40];
  sprintf(tmp, "key_released() k = %02X, mod=%02X\n", k, mod);
  Serial.print(tmp);
}

#if 0
void kbd_event::raw_key_event(uint8_t k, bool released) {
  char tmp[40];
  sprintf(tmp, "raw_key_event() k = %02X, M/B=%d\n", k, released);
  Serial.print(tmp);
}
#endif

void kbd_event::modifier_changed(uint8_t before, uint8_t after) {
  char tmp[40];
  sprintf(tmp, "modifier_changed() %02X --> %02X\n", before, after);
  Serial.print(tmp);
}


ASkeyboard* askb;

void setup() {
  ADCSRA = ADCSRA & 0x7f;
  ACSR = ACSR | 0x80;
  askb = ASkeyboard::getInstance();
  askb->begin(new kbd_event);

  Serial.begin(115200);
  delay(100);  
}

void loop() {
  askb->task(0);
  
}
