/**
 * 
  ps2_hobo_nicola.ino Main sketch of "Hobo-nicola keyboard adapter" (ps/2 keyboard version).
  Copyright (c) 2018 Takeshi Higasa
  
  This file is part of "Hobo-nicola keyboard adapter".

  "Hobo-nicola keyboard adapter" is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  "Hobo-nicola keyboard adapter" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with "Hobo-nicola keyboard adapter".  If not, see <http://www.gnu.org/licenses/>.
  
  
  hoboNicolaLibrary 1.2.1   Dec. 10, 2018
  
*/

#include "nicola_keyboard.h"
#include "ps2_kbd.h"

NicolaKeyboard hobo_nicola;

class ps2_event : public keyboard_notify {
  public:
    virtual void modifier_changed(uint8_t before, uint8_t after) { hobo_nicola.modifier_change(before, after); }
    virtual void raw_key_event(uint8_t key, bool released = false) {};
    virtual void key_pressed  (uint8_t key, uint8_t mod) { hobo_nicola.key_press(key, mod);  };
    virtual void key_released  (uint8_t key, uint8_t mod) { hobo_nicola.key_release(key, mod); };
};

ps2_kbd* ps2;
void setup() {
  ps2 = ps2_kbd::getInstance();
  if (!ps2->begin(new ps2_event, _HBN_NICOLA_LED))
    hobo_nicola.error_blink(400);
}

void loop() {
  ps2->task(hobo_nicola.get_hid_led_state());
  hobo_nicola.idle();
}
