#include "ps2_kbd.h"
ps2_kbd* ps2;

class ps2_event : public keyboard_notify {
public:
    virtual void raw_key_event(uint8_t key, bool released = false);
  virtual void key_pressed(uint8_t k, uint8_t mod);
  virtual void key_released(uint8_t k, uint8_t mod);
  virtual void modifier_changed(uint8_t before, uint8_t after);
};

void ps2_event::raw_key_event(uint8_t scan, bool released) {
  char tmp[20];
  sprintf(tmp, "%02X ", scan);
  Serial.print(tmp);
}

void ps2_event::modifier_changed(uint8_t before, uint8_t after) {
  char tmp[20];
  sprintf(tmp, " [mod : %02X -> %02X]", before, after);
  Serial.println(tmp);
}

void ps2_event::key_pressed(uint8_t k, uint8_t mod) {
  char tmp[20];
  sprintf(tmp, " [%02X, %02X is DOWN]", mod, k);
  Serial.println(tmp);

  if (k == 0x3a)
    ps2->toggle_numlock_led();
  if (k == 0x3b)
    ps2->toggle_capslock_led();
  if (k == 0x3c)
    ps2->toggle_scrlock_led();
}

void ps2_event::key_released(uint8_t k, uint8_t mod) {
  char tmp[20];
  sprintf(tmp, " [%02X, %02X is UP]", mod, k);
  Serial.println(tmp);
}

void setup() {
  ps2 = ps2_kbd::getInstance();
  Serial.begin(115200);
  while (!Serial);
  Serial.println("Start.");
  ps2->begin(new ps2_event, LED_BUILTIN_TX);
} 

void loop() {
  ps2->task();
}
