/**
 * 
  nicola_table.h  Code definitions and related declarations of "Hobo-nicola keyboard adapter".
  Copyright (c) 2018 Takeshi Higasa
  
  This file is part of "Hobo-nicola keyboard adapter".

  "Hobo-nicola keyboard adapter" is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  "Hobo-nicola keyboard adapter" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with "Hobo-nicola keyboard adapter".  If not, see <http://www.gnu.org/licenses/>.
  
*/
#if !defined(__NICOLA_TABLE_H__)
#define __NICOLA_TABLE_H__


#include <Arduino.h>

// nid = 1 to Max_Nid
#define Max_Nid       49

#define NID_LEFT_OYAYUBI	0x80
#define NID_RIGHT_OYAYUBI	0x81
#define NID_SHIFT_KEY		0x82
#define	NID_SETUP_KEY		0xf0

// keys for setup.
#define NID_1		1
#define NID_2		2
#define NID_3		3
#define NID_4		4
#define NID_5		5
#define NID_6		6
#define NID_7		7
#define NID_8		8
#define NID_9		9
#define NID_0		10
#define NID_MINUS	11
#define NID_PIPE	12
#define NID_YEN		13

#define HID_ENTER		0x28
#define HID_ESCAPE		0x29
#define HID_BACKSPACE	0x2a
#define HID_SPACE		0x2c

#define HID_CAPSLOCK	0x39
#define HID_SCRLOCK		0x47
#define HID_PAUSE		0x48

#define HID_ZENHAN		0x35
#define HID_HIRAGANA	0x88
#define HID_HENKAN		0x8a
#define HID_MUHENKAN	0x8b
#define HID_LANG1		0x90	// 
#define HID_LANG2		0x91	// p

#define HID_COLON				0x34
#define HID_LEFT_SQUARE_BRACKET	0x30
#define HID_RIGHT_SQUARE_BRACKET	0x32

#define HID_RIGHT_ARROW	0x4f
#define HID_LEFT_ARROW	0x50
#define HID_DOWN_ARROW	0x51
#define HID_UP_ARROW	0x52
#define HID_DELETE		0x4c

#define LOWBYTE(a) (uint8_t)(a & 0xff)
#define HIGHBYTE(a) (uint8_t)((a >> 8) &  0xff)
#define IsOyayubiKey(a) (LOWBYTE(a) == NID_LEFT_OYAYUBI || LOWBYTE(a) == NID_RIGHT_OYAYUBI)

#endif
